/******************************************************************************

FlashROMANZXCu

œK͖ɂ܂B

2016/8/21 V1.00
sugawara/be-con.jp 
*******************************************************************************/
#include <stdint.h>
#include "machine.h"
#include "iodefine.h"
#include "e2flash.h"


void E2_rd_enable( void );
void E2_rd_disable( void );
void E2_init( void );
int E2_erase( uint8_t *e2add);
int E2_blankcheck( uint8_t *e2add);
int E2_write( uint16_t *e2add,uint16_t *src,int byte );

void e2_wrt_enable( void );
void e2_wrt_disable( void );
static int e2data_flash_blank_check(uint8_t *e2add8 );
static int e2data_flash_write2( uint16_t *e2add16,uint16_t *src16, int num );
static int notify_peri_clock( uint8_t *e2add8 );
static int e2data_flash_block_erase(uint8_t *e2add8 );
static void enter_e2dataflash_pe_mode( void );
static void exit_e2dataflash_pe_mode ( void );
static void data_flash_reset( void );

// 萔

#define	BSP_ICLK_HZ		(32e6)
#define FLASH_CLOCK_HZ 	(32e6)
#define	FCLK_MHZ		(FLASH_CLOCK_HZ/1e6)			//32MhzȂ̂32
#define WAIT_TRESW              (35*(BSP_ICLK_HZ/1000000))
#define WAIT_MAX_ERASE \
        ((int32_t)(60000 * (32.0/(FLASH_CLOCK_HZ/1000000)))*(BSP_ICLK_HZ/1000000))    
#define WAIT_MAX_DF_WRITE \
        ((int32_t)(3200 * (32.0/(FLASH_CLOCK_HZ/1000000)))*(BSP_ICLK_HZ/1000000))
#define WAIT_MAX_BLANK_CHECK \
        ((int32_t)(2500 * (32.0/(FLASH_CLOCK_HZ/1000000)))*(BSP_ICLK_HZ/1000000))
#define WAIT_MAX_NOTIFY_FCU_CLOCK \
        ((int32_t)(60 * (32.0/(FLASH_CLOCK_HZ/1000000)))*(BSP_ICLK_HZ/1000000))         

/*------------------------------------------------------------------------
 *@\	E2tbV̈[hANZXł悤ɂB
 *	
 	FȂ
 *߂l
 	FȂ
 *------------------------------------------------------------------------*/
void E2_rd_enable( void )
{
	FLASH.DFLRE0.WORD = 0x2D0F;
}


/*------------------------------------------------------------------------
 *@\	E2tbV̈[hANZX֎~B
 *	
 	FȂ
 *߂l
 	FȂ
 *------------------------------------------------------------------------*/
void E2_rd_disable( void )
{
	FLASH.DFLRE0.WORD = 0x2D00;
}


/*------------------------------------------------------------------------
 *@\	E2tbV̈CgANZXł悤ɂB
 *	
 	FȂ
 *߂l
 	FȂ
 *------------------------------------------------------------------------*/
void e2_wrt_enable( void )
{
	FLASH.DFLWE0.WORD = (uint16_t)(0x1E00 |0x0F);
}


/*------------------------------------------------------------------------
 *@\	E2tbV̈CgANZX֎~B
 *	
 	FȂ
 *߂l
 	FȂ
 *------------------------------------------------------------------------*/
void e2_wrt_disable( void )
{
	FLASH.DFLWE0.WORD = (uint16_t)(0x1E00 |0x0F);
}


/*------------------------------------------------------------------------
 *@\	E2tbV@\̏
 *	
 	FȂ
 *߂l
 	Ȃ
 *------------------------------------------------------------------------*/
void E2_init( void )
{
	data_flash_reset();
}

/*------------------------------------------------------------------------
 *@\	E2tbVubN
 *	
 	Fuint8_t *e2add@E2f[^tbV
 		0x0010:0000 E2f[^tbV̏ubN擪Ԓn
 *߂l
 	int 1:I 0:G[ 
 *------------------------------------------------------------------------*/
int E2_erase( uint8_t *e2add)
{
	int rslt;
	e2_wrt_enable();
	E2_rd_enable();
	enter_e2dataflash_pe_mode();
	rslt= notify_peri_clock(e2add);
	if(rslt ){
		rslt = e2data_flash_block_erase(e2add);
	}else{
		rslt = 0;
	}
	exit_e2dataflash_pe_mode();
	e2_wrt_disable();

	return rslt;
}


/*------------------------------------------------------------------------
 *@\	E2tbVubN
 *	
 	Fuint8_t *e2add@E2f[^tbV
 		0x0010:0000 E2f[^tbV̏ubN擪Ԓn
 *߂l
 	int 1:uN 0:uNł͂Ȃ/G[ 
 *------------------------------------------------------------------------*/
int E2_blankcheck( uint8_t *e2add)
{
	int rslt = 1;
	
	if(FLASH.DFLBCSTAT.BIT.BCST == 1 ){
		data_flash_reset();
	}
	e2_wrt_enable();
	E2_rd_enable();
	enter_e2dataflash_pe_mode();
	rslt = e2data_flash_blank_check(e2add);
	exit_e2dataflash_pe_mode();
	e2_wrt_disable();
	return rslt;
}


/*------------------------------------------------------------------------
 *@\	E2tbV
 *	
 	uint16_t *e2add:ݐ擪Ԓn@(E2f[^tbV)
 	uint16_t *src  :݃f[^|C^
 	int byte       :݃oCg(Ŏw)
 *߂l
 	int 1:uN 0:uNł͂Ȃ/G[ 
 *------------------------------------------------------------------------*/
int E2_write( uint16_t *e2add,uint16_t *src,int byte )
{
	int rslt;
	int word;

	e2_wrt_enable();
	E2_rd_enable();

	if(byte & 0x0001 )byte+=1;	//byte 𕡐ɂB	
	word = byte / 2 ;
	
	enter_e2dataflash_pe_mode();
	rslt = notify_peri_clock((uint8_t*)e2add);
	if( rslt ) {
		rslt = e2data_flash_write2(e2add,src,word);
	}else{
		rslt = 0;
	}
	
	exit_e2dataflash_pe_mode();
	e2_wrt_disable();

	return rslt;
}


/*------------------------------------------------------------------------
 *@\	E2tbVuN`FbNTu֐@wԒn2oCg`FbN
 *	
 	Fuint8_t *e2add@E2f[^tbV
 		0x0010:0000-0x0010:1FFF E2f[^tbV̏ubN擪Ԓn
 * *߂l
 	int 1:uN 0:uNł͂Ȃ/G[ 
 *------------------------------------------------------------------------*/
static int e2data_flash_blank_check(uint8_t *e2add8 )
{
	int i;
	int rslt=1;
	uint32_t wait;
	uint16_t add;
	
    FLASH.FMODR.BIT.FRDMD = 1;

	for(i=0;i<E2_SIZE;i+=2){
		add = (uint32_t)e2add8;
		add &= 0x07FF;
		FLASH.DFLBCCNT.WORD = add;	//2

		*e2add8 = 0x71;
		*e2add8 = 0xd0;
		wait = WAIT_MAX_BLANK_CHECK;
		while(FLASH.FSTATR0.BIT.FRDY == 0) {
			wait--;
			if(wait==0){
				rslt = 0;
				break;
			}
		};
		if(rslt==0)break;
		if(FLASH.DFLBCSTAT.BIT.BCST == 1 ){
			rslt = 0;
			break;
		}

		e2add8 += 2;
	}
	return rslt;
	
}


/*------------------------------------------------------------------------
 *@\	E2tbV݃Tu֐
 *	
 	uint16_t *e2add16	:ݐ擪Ԓn@(E2f[^tbV)
 	uint16_t *src16		:݃f[^|C^
 	int num				:݃[h (2byte = 1)
 	
  * *߂l
 	int 1:ݐ 0:ݎs 
 *------------------------------------------------------------------------*/
static int e2data_flash_write2( uint16_t *e2add16,uint16_t *src16, int num )
{
	uint8_t *e2add8;
	uint32_t wait;
	int rslt=1;
	
	e2add8 = (uint8_t*)e2add16;
	while(num){
		*e2add8 = 0xe8;
		*e2add8 = 0x01;
		*e2add16 = *src16;
		*e2add8 = 0xd0;
		wait = WAIT_MAX_DF_WRITE;
		while(FLASH.FSTATR0.BIT.FRDY == 0) {
			wait--;
			if(wait==0){
				rslt = 0;
				break;
			}
		};
		if(rslt==0)break;
		if((FLASH.FSTATR0.BIT.ILGLERR == 1) || (FLASH.FSTATR0.BIT.ERSERR  == 1))
		{
			rslt = 0;//FLASH_ERR_FAILURE;
		}
		e2add16++;
		src16++;
		num--;
	}
	return rslt;
}



/*------------------------------------------------------------------------
 *@\	ӃNbNʒm
 *	
 	uint8_t *e2add8 	:ANZXAhX
 	
  * *߂l
 	int 1:ʒm 0:ʒms 
 *------------------------------------------------------------------------*/
static int notify_peri_clock( uint8_t *e2add8 )
{
    uint32_t wait;
    int rslt = 1;
    
    FLASH.PCKAR.WORD = FCLK_MHZ;
    
    *e2add8 = 0xE9;
    *e2add8 = 0x03;
    *(uint16_t*)e2add8 = 0x0F0F;
    *(uint16_t*)e2add8 = 0x0F0F;
    *(uint16_t*)e2add8 = 0x0F0F;
    *e2add8 = 0xD0;
 	wait =  WAIT_MAX_NOTIFY_FCU_CLOCK;
	while(FLASH.FSTATR0.BIT.FRDY == 0) {
		wait--;
		if(wait==0){
			rslt = 0;
			break;
		}
	};
	
    return rslt;
    
}


/*------------------------------------------------------------------------
 *@\	E2tbV
 *	
 	uint8_t *e2add8 	:E2tbVANZX
 	
  * *߂l
 	int 1: 0:s 
 *------------------------------------------------------------------------*/
static int e2data_flash_block_erase(uint8_t *e2add8 )
{
	uint32_t wait;
	int rslt = 1;


	*e2add8 = 0x20;
	*e2add8 = 0xd0;
	wait = WAIT_MAX_ERASE;
	while(FLASH.FSTATR0.BIT.FRDY == 0) {
		wait--;
		if(wait==0){
			rslt = 0;
			break;
		}
	};
    if((FLASH.FSTATR0.BIT.ILGLERR == 1) || (FLASH.FSTATR0.BIT.ERSERR  == 1))
    {
        rslt = 0;
    }


	return rslt;
	
}



/*------------------------------------------------------------------------
 *@\	E2f[^tbVP/E[hڍs
 *	
	
  * *߂l
 *------------------------------------------------------------------------*/
static void enter_e2dataflash_pe_mode( void )
{
    FLASH.FENTRYR.WORD = 0xAA80;
    FLASH.FWEPROR.BYTE = 0x01;
	
}


/*------------------------------------------------------------------------
 *@\	E2f[^tbV[h[hڍs (P/E[hEo)
 *	
	
  * *߂l
 *------------------------------------------------------------------------*/
static void exit_e2dataflash_pe_mode ( void )
{
    FLASH.FENTRYR.WORD = 0xAA00;
    FLASH.FWEPROR.BYTE = 0x02;
}


/*------------------------------------------------------------------------
 *@\	tbVE2f[^tbV[h[hڍs (P/E[hEo)
 *	
	
  * *߂l
 *------------------------------------------------------------------------*/
static void data_flash_reset( void )
{
    volatile int32_t    wait_cnt;

    FLASH.FRESETR.WORD = 0xCC01;

    wait_cnt = WAIT_TRESW;

    while(wait_cnt != 0)
    {
        wait_cnt--;
    }

    FLASH.FRESETR.WORD = 0xCC00;

}

